if (NOT FIND_VRPN_LOADED)

include (${CMAKE_CURRENT_SOURCE_DIR}/cmake/FindHelperMacros.cmake)

if (WIN32)
#  set (VRPN_PREDEF_PATHS "")
  set (VRPN_PREDEF_INCLUDE_SUFFIX include vrpn include/vrpn)
  set (VRPN_PREDEF_LIBRARY_SUFFIX lib)
  FIND_INCLUDE_DIR_MACRO (VRPN VRPN vrpn_Tracker.h VRPN_PREDEF_PATHS VRPN_PREDEF_INCLUDE_SUFFIX)
  FIND_LIBRARY_MACRO (VRPN VRPN vrpn VRPN_PREDEF_PATHS VRPN_PREDEF_LIBRARY_SUFFIX)

  set (VRPN_INCLUDE_DIRS ${VRPN_INCLUDE_DIR})
  set (VRPN_LIBRARIES ${VRPN_vrpn_LIBRARY})

elseif (APPLE AND ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set (VRPN_PREDEF_INCLUDE_SUFFIX include vrpn include/vrpn)
  set (VRPN_PREDEF_LIBRARY_SUFFIX lib)
  FIND_INCLUDE_DIR_MACRO (VRPN VRPN vrpn_Tracker.h VRPN_PREDEF_PATHS VRPN_PREDEF_INCLUDE_SUFFIX)
  FIND_LIBRARY_MACRO (VRPN VRPN vrpnVRPN_PREDEF_PATHS VRPN_PREDEF_LIBRARY_SUFFIX)

  set (VRPN_INCLUDE_DIRS ${VRPN_INCLUDE_DIR})
  set (VRPN_LIBRARIES ${VRPN_vrpn_LIBRARY})
  
elseif (UNIX)
  set (VRPN_PREDEF_INCLUDE_SUFFIX include vrpn include/vrpn)
  set (VRPN_PREDEF_LIBRARY_SUFFIX lib)
  FIND_INCLUDE_DIR_MACRO (VRPN VRPN vrpn_Tracker.h VRPN_PREDEF_PATHS VRPN_PREDEF_INCLUDE_SUFFIX)
  FIND_LIBRARY_MACRO (VRPN VRPN vrpn VRPN_PREDEF_PATHS VRPN_PREDEF_LIBRARY_SUFFIX)

  set (VRPN_INCLUDE_DIRS ${VRPN_INCLUDE_DIR})
  set (VRPN_LIBRARIES ${VRPN_vrpn_LIBRARY})
  
else (WIN32)
  message (FATAL_ERROR "Unable to identify target operating system!")

endif (WIN32)

set (FIND_VRPN_LOADED ON)
endif (NOT FIND_VRPN_LOADED)
